-- Populating Combined Campaign Table
DROP TABLE [ig_reports].[dbo].[I2_CAMP_COMBO]
/****** Script for SelectTopNRows command from SSMS  ******/

SELECT DISTINCT

-- Calling Campaign data from new style table
	[I2_BF_CAMPIGAN_MRR].[CLIENTID], [I2_BF_CAMPIGAN_MRR].[BUSINESSFLOWID],
	[I2_CAMPAIGN_SCD].[CAMPAIGN_ID],
  [I2_BF_CAMPIGAN_MRR].[BUSINESSFLOWTYPE],

-- Calling campaign data from the old table style	
  [I2_CAMPAIGN_SCD].[NAME], [I2_CAMPAIGN_SCD].[DESCRIPTION],
  [I2_CAMPAIGN_SCD].[CREATE_DATE], [I2_CAMPAIGN_SCD].[CAMP_START_DATE],
  [I2_CAMPAIGN_SCD].[DURATION],
	[I2_CAMPAIGN_SCD].[OWNER],
	-- [I2_CAMPAIGN_SCD].[DEFAULT_CERTIFIER], [I2_CAMPAIGN_SCD].[INITIATOR],
	[I2_CAMPAIGN_SCD].[CONFIGURATION],
  [I2_CAMPAIGN_SCD].[TYPE],
	[I2_CAMPAIGN_SCD].[CAMP_END_DATE],
  --[I2_CAMPAIGN_SCD].[ARCHIVE_DATE], [I2_CAMPAIGN_SCD].[IS_IN_PROGRESS],
  --[I2_CAMPAIGN_SCD].[HAS_COMPLETED], [I2_CAMPAIGN_SCD].[IS_ARCHIVED],
  --[I2_CAMPAIGN_SCD].[IS_STOPPED], [I2_CAMPAIGN_SCD].[IS_PURGING],
	--[I2_CAMPAIGN_SCD].[START_DATE], [I2_CAMPAIGN_SCD].[IS_DELETED],
  --[I2_CAMPAIGN_SCD].[END_DATE], 
  --[I2_CAMPAIGN_SCD].[LATEST_IND],
  --[I2_CAMPAIGN_SCD].[CAMP_START_DATE_CH_IND],
  --[I2_CAMPAIGN_SCD].[IS_IN_PROGRESS_CH_IND],
  --[I2_CAMPAIGN_SCD].[HAS_COMPLETED_CH_IND], [I2_CAMPAIGN_SCD].[IS_ARCHIVED_CH_IND],
  --[I2_CAMPAIGN_SCD].[IS_STOPPED_CH_IND], [I2_CAMPAIGN_SCD].[IS_PURGING_CH_IND],
  --[I2_CAMPAIGN_SCD].[CAMP_END_DATE_CH_IND],
  --[I2_CAMPAIGN_SCD].[ARCHIVE_DATE_CH_IND],
	
-- Calling New Campaign Task IDs
  --[I2_BFCAMPTASKS_MRR].[CLIENTID], [I2_BFCAMPTASKS_MRR].[BUSINESSFLOWID],
	[I2_BFCAMPTASKS_MRR].[TASKID] AS [NW_CMP_TASKID],
	[I2_BFCAMPTASKS_MRR].[PARENTID], [I2_BFCAMPTASKS_MRR].[PROCESSREFERENCE],

--Calling Old Campaign Task IDs
  --I2_CAMPAIGN_TASK_SCD].[CLIENT_ID], [I2_CAMPAIGN_TASK_SCD].[CAMPAIGN_ID], 
  [I2_CAMPAIGN_TASK_SCD].[CAMPAIGN_TASK_ID] AS [OLD_CMP_TASKID]
	
  INTO [ig_reports].[dbo].[I2_CAMP_COMBO]
  FROM [ig_reports].[dbo].[I2_CAMPAIGN_SCD]

  INNER JOIN [ig_reports].[dbo].[I2_BF_CAMPIGAN_MRR] ON
    [I2_BF_CAMPIGAN_MRR].[NAME] = [I2_CAMPAIGN_SCD].[NAME]

  INNER JOIN [ig_reports].[dbo].[I2_BFCAMPTASKS_MRR] ON
	[I2_BFCAMPTASKS_MRR].[CLIENTID] = [I2_BF_CAMPIGAN_MRR].[CLIENTID]

  INNER JOIN [ig_reports].[dbo].[I2_CAMPAIGN_TASK_SCD] ON 
    [I2_CAMPAIGN_TASK_SCD].[CLIENT_ID] = [I2_CAMPAIGN_SCD].[CLIENT_ID]

  WHERE	([I2_CAMPAIGN_SCD].[LATEST_IND] = '1' AND
    [I2_CAMPAIGN_TASK_SCD].[LATEST_IND] = '1')
    [I2_BFCAMPTASKS_MRR].[BUSINESSFLOWID] IN
		(SELECT DISTINCT [EV_CMP_MRRII].[BUSINESSFLOWID]
			FROM [ig_reports].[dbo].[I2_BF_CAMPIGAN_MRR] [EV_CMP_MRRII]
			WHERE [I2_BFCAMPTASKS_MRR].[CLIENTID] = [EV_CMP_MRRII].[CLIENTID]) AND
    [I2_CAMPAIGN_TASK_SCD].[CAMPAIGN_ID] IN
		(SELECT DISTINCT [EV_CMP_SCDII].[CAMPAIGN_ID]
			FROM [ig_reports].[dbo].[I2_CAMPAIGN_SCD] [EV_CMP_SCDII]
			WHERE [I2_CAMPAIGN_TASK_SCD].[CLIENT_ID] = [EV_CMP_SCDII].[CLIENT_ID])
			
	 
-- Populating Combined Campaign-Reviewer Action
SELECT DISTINCT [I2C_T].[CLIENT_ID], [I2C_T].[CAMPAIGN_ID], 
  [I2C_T].[CAMPAIGN_TASK_ID],
	[I2C_T].[TASK_STATE], [I2C_T].[RESULT],
  [I2C_T].[PRIMARY_ENTITY_ID], [SECONDARY_ENTITY_ID],
  [I2C_T].[TASK_ENT_RELATION_TYPE], [I2C_T].[LAST_CERTIFIED],
  [I2C_T].[START_DATE],
  --[I2C_T].[IS_DELETED], [I2C_T].[END_DATE], [I2C_T].[LATEST_IND],

-- Calling Role Data
	(SELECT DISTINCT [ROLE_NAME]
    FROM [ig_reports].[dbo].[I2_ROLE_SCD]
    WHERE [ENTITY_ID] = [SECONDARY_ENTITY_ID]
      AND [LATEST_IND] = '1') AS [ROLE_NAME],
  --[I2C_TA].[CLIENT_ID], [I2C_TA].[CAMPAIGN_ID],
  --[I2C_TA].[TASK_ID], [I2C_TA].[ACTION_ID],
	[I2C_TA].[ACTION_TIME],
  --[I2C_TA].[ACTION_ACTOR],

-- Calling User Data
	(SELECT DISTINCT [USER_NAME]
		FROM [ig_reports].[dbo].[I2_RCM_USER]
		WHERE [ENTITY_ID] = [I2C_TA].[ACTION_ACTOR]
		AND [LATEST_IND] = '1') AS [REVIEWER],
	[I2C_TA].[ACTION_TYPE],
--[I2C_TA].[ACTION_RECEIVER],
	(SELECT DISTINCT [USER_NAME]
		FROM [ig_reports].[dbo].[I2_RCM_USER]
		WHERE [ENTITY_ID] = [I2C_TA].[ACTION_RECEIVER]
		AND [LATEST_IND] = '1') AS [RECEIVER], 
	[I2C_TA].[ACTION_RESPONSIBLE]

-- Calling Comment Data
  --[I2_BFCAMPTASKCOMMENTS_MRR].[CLIENTID], [I2_BFCAMPTASKCOMMENTS_MRR].[BUSINESSFLOWID], [I2_BFCAMPTASKCOMMENTS_MRR].[TASKID], 
  --[I2_BFCAMPTASKCOMMENTS_MRR].[COMMENTID],
	[I2_BFCAMPTASKCOMMENTS_MRR].[CREATIONDATE], [I2_BFCAMPTASKCOMMENTS_MRR].[OWNER],
  [I2_BFCAMPTASKCOMMENTS_MRR].[COMMENTTEXT]

  INTO [ig_reports].[dbo].[I2_CAMP_COMBO_RVWR_ACT]
  FROM [ig_reports].[dbo].[I2_CAMPAIGN_TASK_SCD] [I2C_T]

  JOIN [ig_reports].[dbo].[I2_CAMPAIGN_TASK_ACTIONS] [I2C_TA] ON
    [I2C_TA].[TASK_ID] = [I2C_T].[CAMPAIGN_TASK_ID]
  
  LEFT JOIN [ig_reports].[dbo].[I2_BFCAMPTASKCOMMENTS_MRR] ON
		[I2_BFCAMPTASKCOMMENTS_MRR].[CLIENTID] = [I2_CAMPUSERACTIONS_MRR].[CLIENTID] AND
		[I2_BFCAMPTASKCOMMENTS_MRR].[BUSINESSFLOWID] = [I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID] AND
		[I2_BFCAMPTASKCOMMENTS_MRR].[TASKID] = [I2_CAMPUSERACTIONS_MRR].[TASKID]

  WHERE [I2C_T].[LATEST_IND] = '1'
	

-- Populating Combined Campaign-User Acted On

SELECT DISTINCT
-- Calling Campaign Tasks
  --[I2_BFCAMPTASKS_MRR].[CLIENTID], [I2_BFCAMPTASKS_MRR].[BUSINESSFLOWID],
	[I2_BFCAMPTASKS_MRR].[TASKID],
	[I2_BFCAMPTASKS_MRR].[PARENTID], [I2_BFCAMPTASKS_MRR].[PROCESSREFERENCE],
  --[I2_BFCAMPTASKS_MRR].[JOBID],
  [I2_BFCAMPTASKS_MRR].[TASKENTITIESRELATIONTYPE],
  --[I2_BFCAMPTASKS_MRR].[TASKSTATE],
  --[I2_BFCAMPTASKS_MRR].[TASKTYPE],

  --[I2_BFCAMPTASKS_MRR].[EXECUTEDATE],
	[I2_BFCAMPTASKS_MRR].[RESULT],
  --[I2_BFCAMPTASKS_MRR].[FIRST], [I2_BFCAMPTASKS_MRR].[SECOND], -- Row refers to Primary and Secondary Entity Fields
	[I2_BFCAMPTASKS_MRR].[REFERENCETASKID], [I2_BFCAMPTASKS_MRR].[REFERENCERESULT],

--Calling User Actions	
  --[I2_CAMPUSERACTIONS_MRR].[CLIENTID], [I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID],
  --[I2_CAMPUSERACTIONS_MRR].[TASKID], [I2_CAMPUSERACTIONS_MRR].[USERACTIONID],
	[I2_CAMPUSERACTIONS_MRR].[CONTEXTID],
  --[I2_CAMPUSERACTIONS_MRR].[REFERENCEUSERACTIONID], [I2_CAMPUSERACTIONS_MRR].[CONTEXTORDINAL],
     
  --[I2_CAMPUSERACTIONS_MRR].[OWNER]
	[I2_CAMPUSERACTIONS_MRR].[OWNERASSIGNER],
  --[I2_CAMPUSERACTIONS_MRR].[OWNERSTARTDATE],
	[I2_CAMPUSERACTIONS_MRR].[USERACTIONTYPE], [I2_CAMPUSERACTIONS_MRR].[USERACTIONSTATE],
  --[I2_CAMPUSERACTIONS_MRR].[RESULTMODIFIER], [I2_CAMPUSERACTIONS_MRR].[RESULTSTARTDATE],
  --[I2_CAMPUSERACTIONS_MRR].[RESULT],		
  --[I2_CAMPUSERACTIONS_MRR].[ENTITYLOGIC], [I2_CAMPUSERACTIONS_MRR].[MAINENTITY],[I2_CAMPUSERACTIONS_MRR].[SECONDARYENTITY],
  --[I2_CAMPUSERACTIONS_MRR].[WEIGHT], [I2_CAMPUSERACTIONS_MRR].[TEMPASSIGNEE],
	[I2_CAMPUSERACTIONS_MRR].[GROUPIDS],
  --[I2_CAMPUSERACTIONS_MRR].[DELEGATOR], [I2_CAMPUSERACTIONS_MRR].[USERACTIONDELEGATEEID],
  --[I2_CAMPUSERACTIONS_MRR].[USERACTIONDELEGATORID], [I2_CAMPUSERACTIONS_MRR].[EXECUTIONSTATUS],
  [Role_Entities].[KEY1] AS [ROLE_NAME],
	[User_Entities].[KEY1] AS [SERVICE_NUMBER],
	[User_Entities].[DISPLAYNAME] AS [USER_NAME],
	
-- Calling Previous Owner Action Table
  --[I2_CAMPUAPREVIOUSOWNERS_MRR].[CLIENTID],
	[I2_CAMPUAPREVIOUSOWNERS_MRR].[USERACTIONID],
  [I2_CAMPUAPREVIOUSOWNERS_MRR].[OWNER], [I2_CAMPUAPREVIOUSOWNERS_MRR].[OWNERASSIGNER] AS [S_OWNERASSIGNER],
  [I2_CAMPUAPREVIOUSOWNERS_MRR].[OWNERSTARTDATE], [I2_CAMPUAPREVIOUSOWNERS_MRR].[OWNERENDDATE],

-- Calling Comment Data
--[I2_BFCAMPTASKCOMMENTS_MRR].[CLIENTID], [I2_BFCAMPTASKCOMMENTS_MRR].[BUSINESSFLOWID], [I2_BFCAMPTASKCOMMENTS_MRR].[TASKID], 
--[I2_BFCAMPTASKCOMMENTS_MRR].[COMMENTID],
	[I2_BFCAMPTASKCOMMENTS_MRR].[CREATIONDATE], [I2_BFCAMPTASKCOMMENTS_MRR].[OWNER] AS [COMM_OWNER],
  [I2_BFCAMPTASKCOMMENTS_MRR].[COMMENTTEXT]

	INTO [ig_reports].[dbo].[I2_CAMP_COMBO_USR_ACT_ON]
	
	FROM [ig_reports].[dbo].[I2_BFCAMPTASKS_MRR]
	
	INNER JOIN [ig_reports].[dbo].[I2_CAMPUSERACTIONS_MRR] ON
		[I2_CAMPUSERACTIONS_MRR].[CLIENTID] = [I2_BFCAMPTASKS_MRR].[CLIENTID] AND
		[I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID] = [I2_BFCAMPTASKS_MRR].[BUSINESSFLOWID] AND
		[I2_CAMPUSERACTIONS_MRR].[TASKID] = [I2_BFCAMPTASKS_MRR].[TASKID]
	
	INNER JOIN [ig_reports].[dbo].[I2_BFCAMPENTITIES_MRR] [Role_Entities] ON
		[Role_Entities].[ENTITYID] = [I2_CAMPUSERACTIONS_MRR].[SECONDARYENTITY] AND
		[Role_Entities].[CLIENTID] = [I2_CAMPUSERACTIONS_MRR].[CLIENTID] AND
		[Role_Entities].[BUSINESSFLOWID] = [I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID]
	
	INNER JOIN [ig_reports].[dbo].[I2_BFCAMPENTITIES_MRR] [User_Entities] ON
		[User_Entities].[ENTITYID] = [I2_CAMPUSERACTIONS_MRR].[MAINENTITY] AND
		[User_Entities].[CLIENTID] = [I2_CAMPUSERACTIONS_MRR].[CLIENTID] AND
		[User_Entities].[BUSINESSFLOWID] = [I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID]
	
	LEFT JOIN [ig_reports].[dbo].[I2_CAMPUAPREVIOUSOWNERS_MRR] ON
		[I2_CAMPUAPREVIOUSOWNERS_MRR].[CLIENTID] = [I2_CAMPUSERACTIONS_MRR].[CLIENTID] AND
		[I2_CAMPUAPREVIOUSOWNERS_MRR].[USERACTIONID] = [I2_CAMPUSERACTIONS_MRR].[USERACTIONID]

	LEFT JOIN [ig_reports].[dbo].[I2_BFCAMPTASKCOMMENTS_MRR] ON
		[I2_BFCAMPTASKCOMMENTS_MRR].[CLIENTID] = [I2_CAMPUSERACTIONS_MRR].[CLIENTID] AND
		[I2_BFCAMPTASKCOMMENTS_MRR].[BUSINESSFLOWID] = [I2_CAMPUSERACTIONS_MRR].[BUSINESSFLOWID] AND
		[I2_BFCAMPTASKCOMMENTS_MRR].[TASKID] = [I2_CAMPUSERACTIONS_MRR].[TASKID]
		
--	WHERE [I2_BF_CAMPIGAN_MRR].[NAME] = '202110 BSS Midyear Access Review - Salo Chetty'
--	ORDER BY [I2_BF_CAMPIGAN_MRR].[STARTDATE], [I2_CAMPUSERACTIONS_MRR].[RESULTSTARTDATE],
--		[I2_CAMPUAPREVIOUSOWNERS_MRR].[OWNERSTARTDATE] DESC